import qualified Sound.ALSA.Sequencer.Address as Addr
import qualified Sound.ALSA.Sequencer.Client as Client
import qualified Sound.ALSA.Sequencer.Port as Port
import qualified Sound.ALSA.Sequencer.Event as Event
import qualified Sound.ALSA.Sequencer.Queue as Queue
import qualified Sound.ALSA.Sequencer as SndSeq
import qualified Sound.ALSA.Exception as AlsaExc

main :: IO ()
main = (do
  putStrLn "Starting."
  SndSeq.with SndSeq.defaultName SndSeq.Block $ \h -> do
  Client.setName (h :: SndSeq.T SndSeq.OutputMode) "HS test client"
  putStrLn "Created sequencer."
  Port.withSimple h "one"
     (Port.caps [Port.capRead, Port.capSubsRead]) Port.typeMidiGeneric $ \ p -> do
  putStrLn "Created port."
  x <- Client.getId h
  putStrLn ("My id is: " ++ show x)
  let me = Addr.Cons { Addr.client = x, Addr.port = p }
  getChar
  Event.outputDirect h (e1 me)
  getChar
  return ())
  `AlsaExc.catch` \e ->
     putStrLn $ "alsa_exception: " ++ AlsaExc.show e


e1 :: Addr.T -> Event.T
e1 me = Event.Cons
  { Event.highPriority = False
  , Event.tag = 0
  , Event.queue = Queue.direct
  , Event.timestamp = Event.TickTime 0
  , Event.source = me
  , Event.dest = Addr.subscribers
  , Event.body = Event.NoteEv Event.NoteOn (Event.simpleNote 0 60 100)
  }
